unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls,
  VclTee.TeeGDIPlus, VCLTee.TeEngine, VCLTee.Series, VCLTee.TeeProcs,
  VCLTee.Chart, System.Diagnostics;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    LabeledEdit2: TLabeledEdit;
    Chart1: TChart;
    Series1: TLineSeries;
    Series2: TLineSeries;
    Series3: TPointSeries;
    Series4: TPointSeries;
    CheckBox1: TCheckBox;
    Timer1: TTimer;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private 錾 }
    procedure Setting;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

uses system.Math, System.VarCmplx, Velthuis.BigIntegers,mp_real, mp_cmplx, mp_types, mp_base;

{$R *.dfm}

type
  DArray = array of double;

var
  BM : array of mp_float;       // xk[Cz
  FA : array of mp_float;       // Kz
  PVG : array of mp_float;      // +V
  MVG : array of mp_float;      // -V

  zero, one, two, four : mp_float;
  three, pai, log_2pis2 : mp_float;

const
  KMmax = 1000;                  // KM max   1000

//------------------------------------------------------------------------------
  NB = 150;                            // xk[C  z NB + 1

var
  NumeratorString : array[0..NB] of string;               // q
  DenominatorString  : array[0..NB] of string;            // 

// ő  [Nbȟݏ@ BigInteger
function gcd_BigInteger(x, y: BigInteger): BigInteger;
var
  t : BigInteger;
begin
  while y <> 0 do begin
    t := x mod y;
    x := y;
    y := t;
  end;
  result := x;
end;

// xk[C
// Akiyama-Tanigawa algorithm
// BigInteger
procedure Bernoulli_number_BigInteger;
const
  n = (NB + 1) * 2;
var
  m, j, k : integer;
  a     : array of BigInteger;      // q
  b     : array of BigInteger;      // 
  tmpN  : BigInteger;               // q
  tmpD  : BigInteger;               // 
  gcd   : BigInteger;               // ő
  b0    : BigInteger;
begin
  setlength(a, n + 1);
  setlength(b, n + 1);
  k := 0;
  for m := 0 to n do begin
    a[m] := 1;                         // q l
    b[m] := (m + 1);                                //  l
    for j := m - 1 downto 0 do begin
      tmpN := a[j] * b[j + 1] - a[j + 1] * b[j];    // q
      tmpN := tmpN * (j + 1);                       // V
      tmpD := b[j] * b[j + 1];                      // 
      gcd := gcd_BigInteger(tmpN, tmpD);            // ő
      a[j] := tmpN div gcd;
      b[j] := tmpD div gcd;
    end;
    if (m > 0) and (m mod 2 = 0) then begin
      b0 := b[0];
      b0 := b0 * m * (m -1);                       // m xk[CNo
      NumeratorString[k] := a[0].tostring;
      DenominatorString[k] := b0.tostring;
      inc(k);
    end;
  end;
end;

//------------------------------------------------------------------------------

// OK}{
procedure log_GammaMul(var x, ans : mp_float);
var
  v, w : mp_float;
  tmp, tmp0, s : mp_float;
  i : integer;
begin
  mpf_init2(v, w);
  mpf_init3(tmp, tmp0, s);

  mpf_set1(v);
  mpf_set_int(tmp, NB);
  while mpf_is_lt(x, tmp) do begin
    mpf_mul(v, x, v);
    mpf_add(x, one, x);
  end;
  mpf_mul(x, x, tmp);               // x^2
  mpf_div(one, tmp, w);             // w = 1 / x^2
  mpf_set0(s);
  for i := NB downto 1 do begin
    mpf_add(s, BM[i], tmp);         // tmp = s + B[i]
    mpf_mul(tmp, w, s);             // s = tmp * w
  end;
  mpf_add(s, BM[0], tmp);           // tmp = s + B[0]
  mpf_div(tmp, x, s);               // s = (s + B[0]) / x
  mpf_add(s, log_2pis2, s);         // s = s + ln(2)/2
  mpf_ln(v, tmp);                   // ln(v)
  mpf_sub(s, tmp, s);               // s := s - ln(v)
  mpf_sub(s, x, s);                 // s := s - x
  mpf_div(one, two, tmp);           // tmp = 1/2
  mpf_sub(x, tmp, tmp0);            // tmp0 = x - 1/2
  mpf_ln(x, tmp);                   // ln(x)
  mpf_mul(tmp0, tmp, tmp0);         // tmp0 = (x - 1/2) * ln(x)
  mpf_add(s, tmp0, ans);            // ans = s + (x - 1/2) * ln(x)

  mpf_clear2(v, w);
  mpf_clear3(tmp, tmp0, s);
end;

// {K}
// x̒l 0 ƕ̎́ɂȂ̂łĂ܂̂ŃG[ɂȂ܂B
// Pr͎̎̎gp܂B
procedure gammaMul(var x, ans: mp_float);
var
  tmp, tmp0, logG : mp_float;
begin
  mpf_init3(tmp, tmp0, logG);

  if mpf_is_lt(x, zero) then begin
    mpf_mul(pai, x, tmp);            // x*
    mpf_sin(tmp, tmp0);              // sin(x);
    mpf_sub(one, x, tmp);            // 1-x
    log_GammaMul(tmp, logG);         // loggamma(1-x);
    mpf_exp(logG, logG);             // exp(logG)
    mpf_div(pai, tmp0, tmp);         // /sin(x)
    mpf_div(tmp, logG, ans);         // ans = /(sin(x) * logG(1-x))
  end
  else begin
    log_GammaMul(x, logG);           // logG
    mpf_exp(logG, ans);              // exp(logG)
  end;

  mpf_clear3(tmp, tmp0, logG);
end;

//------------------------------------------------------------------------------

// K {
procedure factorialMul(n : integer);
label
  EXT;
var
  i : integer;
  bi, ans : mp_float;
begin
  mpf_init2(bi, ans);

  mpf_set1(ans);
  mpf_copy(ans, FA[0]);
  mpf_copy(ans, FA[1]);

  mpf_copy(two, bi);

  if n <= 1 then begin
    goto EXT;
  end;
  for i := 2 to n do  begin
    mpf_mul(ans, bi, ans);
    mpf_copy(ans, FA[i]);
    mpf_add(bi, one, bi);
  end;
EXT:
  mpf_clear2(bi, ans);
end;

//------------------------------------------------------------------------------
// jv(x) Iv(x) {
// X l 
// v 
// F  false Jvx  true  Ivx
procedure Jvx(var v : mp_float; var x, ri: mp_float; F : boolean);
var
  k : integer;
  s, x24k, tmp, tmp0, tmp1 : mp_float;
  xc, xs2: mp_float;
  kd, nd, vk : mp_float;
  khg, kf : mp_float;
  tmf, tmf0 : mp_float;
  sb : mp_float;
begin
  mpf_init5(s, x24k, tmp, tmp0, tmp1);
  mpf_init2(xc, xs2);
  mpf_init2(khg, kf);
  mpf_init3(kd, nd, vk);
  mpf_init2(tmf, tmf0);
  mpf_init(sb);

  mpf_set0(s);                              // =0
  mpf_set0(sb);

  mpf_div(x, two, xs2);                     // x / 2
  mpf_mul(xs2, xs2, xc);                    // (x^2)/ 4
  mpf_set1(x24k);                           // x24k = 1
  for k := 0 to KMmax do begin
    mpf_set1(nd);
    mpf_set_int(kf, k);                     // kf = k
    mpf_add(v, kf, tmf0);                   // k + v
    mpf_add(tmf0, one, vk);                 // vk = k + v + 1;
    if mpf_is_lt(vk, zero) then begin       // vk < 0  nxmF
      mpf_int(vk, tmf);                     // int(vk);
      mpf_sub(vk, tmf, nd);                 // vk - int(vk) vk̐ vk = 0
    end;
    if mpf_is_ne(vk, zero) and mpf_is_ne(nd, zero) then begin  // vk̐̎͌vZȂ
      if mpf_is_ge(v, zero) then
        mpf_copy(PVG[k], tmf)               // (v+k+1) v>= 0
      else
        mpf_copy(MVG[k], tmf);              // (v+k+1) v < 0
      mpf_mul(FA[k], tmf, khg);             // k!(n+k+1) vk0,̐̎}
      mpf_div(x24k, khg, tmp0);             // ((i(x^2)/4)^k)/(k!(v+k+1))
      if F = false then
        if k mod 2 <> 0 then mpf_chs(tmp0, tmp0);   // (-1)^k
      mpf_add(s, tmp0, s);                  // 
      mpf_sub(s, sb, tmp0);
      if mpf_is0(tmp0) then break;
      mpf_copy(s, sb);
    end;
    mpf_mul(x24k, xc, x24k);                // ((x^2)/4)^k
  end;
  // x 0Ŏv̎powerZ[ł̏Zh~
  if mpf_is0(x) and mpf_is_lt(v, zero) then // V<0 x=0 ͖ɂȂ̂ŌvZȂ
  else begin
    mpf_expt(xs2, v, tmp0);                 // (x/2)^v
    mpf_mul(s, tmp0, s);                    // (x/2)^v * 
  end;
  mpf_copy(s, ri);

  mpf_clear5(s, x24k, tmp, tmp0, tmp1);
  mpf_clear2(xc, xs2);
  mpf_clear2(khg, kf);
  mpf_clear3(kd, nd, vk);
  mpf_clear2(tmf, tmf0);
  mpf_clear(sb);
end;

// z̒l z < 0 ̎OtpɋߎlvZ
procedure AiryS_functions(z : mp_float; var Ai, Bi : mp_float);
var
  zh3s2, pis4, zh1s4, rpi, tmp : mp_float;
  n23zppi4, sincos, az : mp_float;
begin
  mpf_init5(zh3s2, pis4, zh1s4, rpi, tmp);
  mpf_init3(n23zppi4, sincos, az);

  mpf_abs(z, az);                             // |Z|

  mpf_div(one, four, tmp);                    // 1/4
  mpf_expt(az, tmp, zh1s4);                   // z^(1/4)
  mpf_sqrt(pai, rpi);                         // 
  mpf_div(pai, four, pis4);                   // /4
  mpf_div(three, two, tmp);                   // 3/2
  mpf_expt(az, tmp, zh3s2);                   // z^(3/2)
  mpf_mul(zh3s2, two, tmp);                   // 2(z^(3/2))
  mpf_div(tmp, three, tmp);                   // 2/3((z^(3/2)))
  mpf_add(tmp, pis4, n23zppi4);               // 2/3((z^(3/2))) + /4
  mpf_sin(n23zppi4, sincos);                  // sin(2/3((z^(3/2))) + /4)
  mpf_div(sincos, rpi, tmp);                  // sin/
  mpf_div(tmp, zh1s4, Ai);                    // sin//z^(1/4)

  mpf_cos(n23zppi4, sincos);                  // cos(2/3((z^(3/2))) + /4)
  mpf_div(sincos, rpi, tmp);                  // cos/
  mpf_div(tmp, zh1s4, Bi);                    // cos//z^(1/4)

  mpf_clear5(zh3s2, pis4, zh1s4, rpi, tmp);
  mpf_clear3(n23zppi4, sincos, az);
end;

// z̒l z > 0 ̎OtpɋߎlvZ
procedure AiryL_functions(z : mp_float; var Ai, Bi : mp_float);
var
  zh3s2, zh1s4, ehmzh3s2, tmp : mp_float;
  rpi, n2s3z3s2: mp_float;
begin
  mpf_init4(zh3s2, zh1s4, ehmzh3s2, tmp);
  mpf_init2(rpi, n2s3z3s2);

  mpf_div(three, two, tmp);               // 3/2
  mpf_expt(z, tmp, zh3s2);                // z^(3/2)
  mpf_mul(zh3s2, two, tmp);               // 2z^(3/2)
  mpf_div(tmp, three, n2s3z3s2);          // (2/3)z^(3/2)
  mpf_chs(n2s3z3s2, tmp);                 // -(2/3)z^(3/2)
  mpf_exp(tmp, ehmzh3s2);                 // e^(-(2/3)z^(3/2))
  mpf_div(one, four, tmp);                // 1/4
  mpf_expt(z, tmp, zh1s4);                // z^(1/4)
  mpf_sqrt(pai, rpi);                     // 
  mpf_div(ehmzh3s2, two, tmp);            // (e^(-(2/3)z^(3/2)))/2
  mpf_div(tmp, rpi, tmp);                 // (e^(-(2/3)z^(3/2)))/2/
  mpf_div(tmp, zh1s4, Ai);                // Ai = (e^(-(2/3)z^(3/2)))/2//z^(1/4)

  mpf_exp(n2s3z3s2, ehmzh3s2);            // e^((2/3)z^(3/2))
  mpf_div(ehmzh3s2, rpi, tmp);            // (e^((2/3)z^(3/2)))/
  mpf_div(tmp, zh1s4, Bi);                // Bi = (e^((2/3)z^(3/2)))//z^(1/4)

  mpf_clear4(zh3s2, zh1s4, ehmzh3s2, tmp);
  mpf_clear2(rpi, n2s3z3s2);
end;

// Airy֐ {
procedure Airy_functions(z : mp_float; var Ai, Bi : mp_float);
var
  pv, mv, az: mp_float;
  z32, s23, rz, r3, s32 : mp_float;
  sz32, Ipv, Imv, Jpv, Jmv : mp_float;
  g23, s16, p323, p316 : mp_float;
begin
  mpf_init3(pv, mv, az);
  mpf_init5(z32, s23, rz, r3, s32);
  mpf_init5(sz32, Ipv, Imv, Jpv, Jmv);
  mpf_init4(g23, s16, p323, p316);
  mpf_div(one, three, pv);          // +v = 1/3
  mpf_chs(pv, mv);                  // -v = -1/3
  mpf_div(two, three, s23);         // 2/3
  mpf_div(pv, two, s16);            // 1/6 = 1/3/2
  mpf_div(three, two, s32);         // 3/2
  mpf_abs(z, az);                   // |z|
  if mpf_is0(z) then begin
    mpf_expt(three, s23, p323);     // 3^(2/3)
    gammaMul(s23, g23);             // (2/3)
    mpf_div(one, p323, Ai);         // 1/3^(2/3)
    mpf_div(Ai, g23, Ai);           // Ai=1/3^(2/3)/(2/3)
    mpf_expt(three, s16, p316);     // 3^(1/6)
    mpf_div(one, p316, Bi);         // 1/3^(1/6)
    mpf_div(Bi, g23, Bi);           // Bi=1/3^(1/6)/(2/3);
  end
  else begin
    mpf_expt(az, s32, z32);          // z^(3/2)
    mpf_mul(z32, s23, sz32);        // (2/3)Z^(3/2)
    mpf_sqrt(az, rz);               // z
    mpf_sqrt(three, r3);            // 3
    if mpf_is_ge(z, zero) then begin
      Jvx(pv, sz32, Ipv, true);     // I+v
      Jvx(mv, sz32, Imv, true);     // I-v
      mpf_sub(Imv, Ipv, Ai);        // =I(-v) - I(+v)
      mpf_mul(Ai, rz, Ai);          // z
      mpf_div(Ai, three, Ai);       // Ai = (z)/3
      mpf_add(Imv, Ipv, Bi);        // =I(-v) + I(+v)
      mpf_mul(Bi, rz, Bi);          // z
      mpf_div(Bi, r3, Bi);          // Bi = (z)/3
//      Form1.memo1.Lines.Append( string('I+v = ' + mpf_decimal(Ipv, 50)));
//      Form1.memo1.Lines.Append( string('I-v = ' + mpf_decimal(Imv, 50)));
    end
    else begin
      Jvx(pv, sz32, Jpv, false);    // J+v
      Jvx(mv, sz32, Jmv, false);    // J-v
      mpf_add(Jmv, Jpv, Ai);        // =J(-v) + J(+v)
      mpf_mul(Ai, rz, Ai);          // z
      mpf_div(Ai, three, Ai);       // Ai = (z)/3
      mpf_sub(Jmv, Jpv, Bi);        // =J(-v) - J(+v)
      mpf_mul(Bi, rz, Bi);          // z
      mpf_div(Bi, r3, Bi);          // Bi=(z)/3
//      Form1.memo1.Lines.Append( string('J+v = ' + mpf_decimal(Jpv, 50)));
//      Form1.memo1.Lines.Append( string('J-v = ' + mpf_decimal(Jmv, 50)));
    end;
  end;

  mpf_clear3(pv, mv, az);
  mpf_clear5(z32, s23, rz, r3, s32);
  mpf_clear5(sz32, Ipv, Imv, Jpv, Jmv);
  mpf_clear4(g23, s16, p323, p316);
end;

// x ͒lE
// XinMIN <= xin <= XinMAX  ͈͊Ȍꍇ덷傫Ȃ܂B
// 덷Ȃׂɂ́AZƁAl̏kmax xk[Cp NBl傫
// KvL܂A܏ꍇŏ̔z̏̎ԂȂ܂B
const
  XinMIN = -80;
  XinMAX = 50;

// vZ
// x̒l傫Ȃƌ덷傫Ȃ܂B
procedure TForm1.Button1Click(Sender: TObject);
label
  EXT;
const
  N = 100;
  XLIN = 5;
  CHA = -3;
var
  ch, i, NN : integer;
  xin : double;
  xmin, xmax, dx, xg : double;
  xf, xm, Ai, Bi : mp_float;
  StopWatch : TStopwatch;
  ElapsedMillseconds : Int64;
  mm, ss, ms : integer;
begin
  memo1.Clear;
  memo1.Font.Size := 11;
  val(labelededit2.Text, xin, ch);
  if ch <> 0 then begin
    application.MessageBox('x̒lɊԈႢ܂B','', 0);
    exit;
  end;

  if xin < XinMIN then begin
    application.MessageBox(PWideChar('x̐Βl' + intTostr(XinMIN) + '傫ĉB'),'', 0);
    exit;
  end;
  if XinMAX > XinMAX then begin
    application.MessageBox(PWideChar('x̐Βl' + intTostr(XinMAX) + '菬ĉB'),'', 0);
    exit;
  end;

  mpf_init4(xf, xm, Ai, Bi);

  series1.Clear;
  series2.Clear;
  series3.Clear;
  series4.Clear;

  application.ProcessMessages;

  mpf_read_decimal(xm, PAnsiChar(ansistring(labelededit2.Text + #00)));

  StopWatch := TStopwatch.StartNew;

  Airy_functions(xm, Ai, Bi);

  memo1.Lines.Append('GA[֐');

  memo1.Lines.Append( string('Ai(x) = ' + mpf_decimal(Ai, 50)));
  memo1.Lines.Append( string('Bi(x) = ' + mpf_decimal(Bi, 50)));

  StopWatch.Stop;
  ElapsedMillseconds := StopWatch.ElapsedMilliseconds;

  ms := ElapsedMillseconds * N + 500;
  mm := ms div 60000;
  ss := (ms mod 60000) div 1000;
  NN := N;
  if (xin <= abs(CHA)) and (xin >= CHA) then
    memo1.Lines.Append('Ot\ɖ' + inttostr(mm) + '' + inttostr(ss) + 'bKvłB')
  else begin
    memo1.Lines.Append('Ot\ɖ2bKvłB');
    NN := N * 2;
  end;

  if checkbox1.Checked = false then begin          // OtI
      Chart1.Canvas.Font.Style := [fsBold];
      Chart1.Canvas.Font.size := 8;
      Chart1.Canvas.TextOut(170, 115,'Ot');
    goto EXT;
  end;

// Ot\
  series3.AddXY(xin, mpf_todouble(Ai));
  series4.AddXY(xin, mpf_todouble(Bi));
  xmin := round(xin) - 8;
  xmax := xmin + 13;
  dx := (xmax - xmin) / NN;
  for i := 0 to NN do begin
    xg := dx * i + xmin;
    mpf_set_dbl(xf, xg);

    if xg > abs(CHA) then AiryL_functions(xf, Ai, Bi)
    else
      if xg < CHA then AiryS_functions(xf, Ai, Bi)
      else
        Airy_functions(xf, Ai, Bi);
    series1.AddXY(xg, mpf_todouble(Ai));
    series2.AddXY(xg, mpf_todouble(Bi));
  end;

  application.ProcessMessages;
EXT:
  mpf_clear4(xf, xm, Ai, Bi);
end;

// ݒ
// vZpz񏀔
// xbZ֐ɗ^ϐ̒lz=(2/3)x^(3/2)ƂȂ80Ŗ4.8f{A100ƂƖ6{666ƂȂ̂
// (z/2)^2k ̌vZI[o[t[Ȃ悤ɂKv艉Z̗L傫܂B
// ʏ̏ꍇz=100180  Airy̏ꍇx=80300ƂȂ܂B
// L傫ƁA֐z̏ɎԂ|̂ŁA҂\܂B
procedure TForm1.Setting;
var
  i, k : integer;
  N, D, tmp : mp_float;
  vm, avm, tmf, tmf0 : mp_float;
  nd, vk : mp_float;
begin
  mpf_set_default_decprec(300);         // L300 50̐xɕKvłB
  setlength(BM, NB + 1);                // xk[Cz
  setlength(FA, KMmax + 1);             // K!z
  setlength(PVG, KMmax + 1);            // +v
  setlength(MVG, KMmax + 1);            // -v


  for i := 0 to NB do mpf_init(BM[i]);
  for i := 0 to KMmax do mpf_init(FA[i]);
  for i := 0 to KMmax do mpf_init(PVG[i]);
  for i := 0 to KMmax do mpf_init(MVG[i]);

  mpf_init3(N, D, tmp);
  mpf_init4(zero, one, two, four);
  mpf_init3(three, pai, log_2pis2);
  mpf_init4(vm, avm, tmf, tmf0);
  mpf_init2(nd, vk);

  mpf_set0(zero);
  mpf_set1(one);
  mpf_set_int(two, 2);
  mpf_set_int(three, 3);
  mpf_set_int(four, 4);
  mpf_set_pi(pai);

  mpf_mul(pai, two, tmp);          // 2
  mpf_ln(tmp, tmp);                // ln(2)
  mpf_div(tmp, two, log_2pis2);    // ln(2)/2


  Bernoulli_number_BigInteger;              //  xk[C쐬

  for i := 0 to NB do begin
    mpf_read_decimal(N, PAnsiChar(ansistring(NumeratorString[i] + #00)));
    mpf_read_decimal(D, PAnsiChar(ansistring(DenominatorString[i] + #00)));
    mpf_div(N, D, BM[i]);
  end;

  factorialMul(kMmax);                      // 0!`KMmax!

  mpf_div(one, three, vm);                  // v 1/3
  for k := 0 to KMmax do begin
    mpf_set_int(tmf, k);                    // k
    mpf_add(tmf, vm, tmf0);                 // v + k
    mpf_add(tmf0, one, vk);                 // vk= v + k + 1
    gammaMul(vk, PVG[k]);                   // (v+k+1)
  end;
  mpf_chs(vm, avm);                         // -v  -1/3
  for k := 0 to KMmax do begin
    mpf_set1(nd);
    mpf_set_int(tmf, k);                    // k
    mpf_add(tmf, avm, tmf0);                // -v + k
    mpf_add(tmf0, one, vk);                 // vk= -v + k + 1
    if mpf_is_lt(vk, zero) then begin       // vk < 0  nxmF
      mpf_int(vk, tmf);                     // int(vk);
      mpf_sub(vk, tmf, nd);                 // vk - int(vk) vk̐ nd = 0
    end;
    if mpf_is_ne(vk, zero) and mpf_is_ne(nd, zero) then // vk̐̎͌vZȂ
      gammaMul(vk, MVG[k])                  // (v+k+1)
    else
      mpf_set0(MVG[k]);                     // (v+k+1) = 0
  end;

  memo1.Clear;
  memo1.Font.Color := clBlack;
  memo1.Lines.Append('');
  memo1.Lines.Append('             ');
  Labelededit2.EditLabel.Caption := 'x (' + inttostr(XinMIN) + 'x' + inttostr(XinMAX) + ')';

  Button1.Enabled := True;

  mpf_clear3(N, D, tmp);
  mpf_clear4(vm, avm, tmf, tmf0);
  mpf_clear2(nd, vk);
end;

// X^[g\
procedure TForm1.FormCreate(Sender: TObject);
begin
  Button1.Enabled := False;
  memo1.Clear;
  memo1.Font.Size := 18;
  memo1.Font.Color := clRed;
  memo1.Lines.Append('');
  memo1.Lines.Append('             vZpz񏀔');
  Timer1.Interval := 200;
  Timer1.Enabled := True;
end;

//
procedure TForm1.Timer1Timer(Sender: TObject);
begin
  Timer1.Enabled := False;
  Setting;
end;

// I
procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var
  i : integer;
begin
  for i := 0 to NB do mpf_clear(BM[i]);
  for i := 0 to KMmax do mpf_clear(FA[i]);
  for i := 0 to KMmax do mpf_clear(PVG[i]);
  for i := 0 to KMmax do mpf_clear(MVG[i]);
  mpf_clear4(zero, one, two, four);
  mpf_clear3(three, pai, log_2pis2);
end;

end.
