unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls,
  VclTee.TeeGDIPlus, VCLTee.TeEngine, VCLTee.Series, VCLTee.TeeProcs,
  VCLTee.Chart, System.Diagnostics;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    LabeledEdit2: TLabeledEdit;
    Chart1: TChart;
    Series1: TLineSeries;
    Series2: TLineSeries;
    Series3: TPointSeries;
    Series4: TPointSeries;
    CheckBox1: TCheckBox;
    Timer1: TTimer;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private 錾 }
    procedure Setting;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

uses system.Math, System.VarCmplx, Velthuis.BigIntegers,mp_real, mp_cmplx, mp_types, mp_base;

{$R *.dfm}

type
  DArray = array of double;

var
  BM : array of mp_float;       // xk[Cz
  FA : array of mp_float;       // Kz
  PVG : array of mp_float;      // +V
  MVG : array of mp_float;      // +V

  zero, one, two, four : mp_float;
  three, pai, log_2pis2 : mp_float;

const
  KMmax = 1000;                  // KM max   1000

//------------------------------------------------------------------------------
  NB = 150;                            // xk[C  z NB + 1

var
  NumeratorString : array[0..NB] of string;               // q
  DenominatorString  : array[0..NB] of string;            // 

// ő  [Nbȟݏ@ BigInteger
function gcd_BigInteger(x, y: BigInteger): BigInteger;
var
  t : BigInteger;
begin
  while y <> 0 do begin
    t := x mod y;
    x := y;
    y := t;
  end;
  result := x;
end;

// xk[C
// Akiyama-Tanigawa algorithm
// BigInteger
procedure Bernoulli_number_BigInteger;
const
  n = (NB + 1) * 2;
var
  m, j, k : integer;
  a     : array of BigInteger;      // q
  b     : array of BigInteger;      // 
  tmpN  : BigInteger;               // q
  tmpD  : BigInteger;               // 
  gcd   : BigInteger;               // ő
  b0    : BigInteger;
begin
  setlength(a, n + 1);
  setlength(b, n + 1);
  k := 0;
  for m := 0 to n do begin
    a[m] := 1;                         // q l
    b[m] := (m + 1);                                //  l
    for j := m - 1 downto 0 do begin
      tmpN := a[j] * b[j + 1] - a[j + 1] * b[j];    // q
      tmpN := tmpN * (j + 1);                       // V
      tmpD := b[j] * b[j + 1];                      // 
      gcd := gcd_BigInteger(tmpN, tmpD);            // ő
      a[j] := tmpN div gcd;
      b[j] := tmpD div gcd;
    end;
    if (m > 0) and (m mod 2 = 0) then begin
      b0 := b[0];
      b0 := b0 * m * (m -1);                       // m xk[CNo
      NumeratorString[k] := a[0].tostring;
      DenominatorString[k] := b0.tostring;
      inc(k);
    end;
  end;
end;

//------------------------------------------------------------------------------

// OK}{
procedure log_GammaMul(var x, ans : mp_float);
var
  v, w : mp_float;
  tmp, tmp0, s : mp_float;
  i : integer;
begin
  mpf_init2(v, w);
  mpf_init3(tmp, tmp0, s);

  mpf_set1(v);
  mpf_set_int(tmp, NB);
  while mpf_is_lt(x, tmp) do begin
    mpf_mul(v, x, v);
    mpf_add(x, one, x);
  end;
  mpf_mul(x, x, tmp);               // x^2
  mpf_div(one, tmp, w);             // w = 1 / x^2
  mpf_set0(s);
  for i := NB downto 1 do begin
    mpf_add(s, BM[i], tmp);         // tmp = s + B[i]
    mpf_mul(tmp, w, s);             // s = tmp * w
  end;
  mpf_add(s, BM[0], tmp);           // tmp = s + B[0]
  mpf_div(tmp, x, s);               // s = (s + B[0]) / x
  mpf_add(s, log_2pis2, s);         // s = s + ln(2)/2
  mpf_ln(v, tmp);                   // ln(v)
  mpf_sub(s, tmp, s);               // s := s - ln(v)
  mpf_sub(s, x, s);                 // s := s - x
  mpf_div(one, two, tmp);           // tmp = 1/2
  mpf_sub(x, tmp, tmp0);            // tmp0 = x - 1/2
  mpf_ln(x, tmp);                   // ln(x)
  mpf_mul(tmp0, tmp, tmp0);         // tmp0 = (x - 1/2) * ln(x)
  mpf_add(s, tmp0, ans);            // ans = s + (x - 1/2) * ln(x)

  mpf_clear2(v, w);
  mpf_clear3(tmp, tmp0, s);
end;

// {K}
// x̒l 0 ƕ̎́ɂȂ̂łĂ܂̂ŃG[ɂȂ܂B
// Pr͎̎̎gp܂B
procedure gammaMul(var x, ans: mp_float);
var
  tmp, tmp0, logG : mp_float;
begin
  mpf_init3(tmp, tmp0, logG);

  if mpf_is_lt(x, zero) then begin
    mpf_mul(pai, x, tmp);            // x*
    mpf_sin(tmp, tmp0);              // sin(x);
    mpf_sub(one, x, tmp);            // 1-x
    log_GammaMul(tmp, logG);         // loggamma(1-x);
    mpf_exp(logG, logG);             // exp(logG)
    mpf_div(pai, tmp0, tmp);         // /sin(x)
    mpf_div(tmp, logG, ans);         // ans = /(sin(x) * logG(1-x))
  end
  else begin
    log_GammaMul(x, logG);           // logG
    mpf_exp(logG, ans);              // exp(logG)
  end;

  mpf_clear3(tmp, tmp0, logG);
end;

//------------------------------------------------------------------------------

// K {
procedure factorialMul(n : integer);
label
  EXT;
var
  i : integer;
  bi, ans : mp_float;
begin
  mpf_init2(bi, ans);

  mpf_set1(ans);
  mpf_copy(ans, FA[0]);
  mpf_copy(ans, FA[1]);

  mpf_copy(two, bi);

  if n <= 1 then begin
    goto EXT;
  end;
  for i := 2 to n do  begin
    mpf_mul(ans, bi, ans);
    mpf_copy(ans, FA[i]);
    mpf_add(bi, one, bi);
  end;
EXT:
  mpf_clear2(bi, ans);
end;

//------------------------------------------------------------------------------

// z̒l z < 0 ̎OtpɋߎlvZ
procedure AiryS_functions(z : mp_float; var Ai, Bi : mp_float);
var
  zh3s2, pis4, zh1s4, rpi, tmp : mp_float;
  n23zppi4, sincos, az : mp_float;
begin
  mpf_init5(zh3s2, pis4, zh1s4, rpi, tmp);
  mpf_init3(n23zppi4, sincos, az);

  mpf_abs(z, az);                             // |Z|

  mpf_div(one, four, tmp);                    // 1/4
  mpf_expt(az, tmp, zh1s4);                   // z^(1/4)
  mpf_sqrt(pai, rpi);                         // 
  mpf_div(pai, four, pis4);                   // /4
  mpf_div(three, two, tmp);                   // 3/2
  mpf_expt(az, tmp, zh3s2);                   // z^(3/2)
  mpf_mul(zh3s2, two, tmp);                   // 2(z^(3/2))
  mpf_div(tmp, three, tmp);                   // 2/3((z^(3/2)))
  mpf_add(tmp, pis4, n23zppi4);               // 2/3((z^(3/2))) + /4
  mpf_sin(n23zppi4, sincos);                  // sin(2/3((z^(3/2))) + /4)
  mpf_div(sincos, rpi, tmp);                  // sin/
  mpf_div(tmp, zh1s4, Ai);                    // sin//z^(1/4)

  mpf_cos(n23zppi4, sincos);                  // cps(2/3((z^(3/2))) + /4)
  mpf_div(sincos, rpi, tmp);                  // cos/
  mpf_div(tmp, zh1s4, Bi);                    // cos//z^(1/4)

  mpf_clear5(zh3s2, pis4, zh1s4, rpi, tmp);
  mpf_clear3(n23zppi4, sincos, az);
end;

// z̒l z > 0 ̎OtpɋߎlvZ
procedure AiryL_functions(z : mp_float; var Ai, Bi : mp_float);
var
  zh3s2, zh1s4, ehmzh3s2, tmp : mp_float;
  rpi, n2s3z3s2: mp_float;
begin
  mpf_init4(zh3s2, zh1s4, ehmzh3s2, tmp);
  mpf_init2(rpi, n2s3z3s2);

  mpf_div(three, two, tmp);               // 3/2
  mpf_expt(z, tmp, zh3s2);                // z^(3/2)
  mpf_mul(zh3s2, two, tmp);               // 2z^(3/2)
  mpf_div(tmp, three, n2s3z3s2);          // (2/3)z^(3/2)
  mpf_chs(n2s3z3s2, tmp);                 // -(2/3)z^(3/2)
  mpf_exp(tmp, ehmzh3s2);                 // e^(-(2/3)z^(3/2))
  mpf_div(one, four, tmp);                // 1/4
  mpf_expt(z, tmp, zh1s4);                // z^(1/4)
  mpf_sqrt(pai, rpi);                     // 
  mpf_div(ehmzh3s2, two, tmp);            // (e^(-(2/3)z^(3/2)))/2
  mpf_div(tmp, rpi, tmp);                 // (e^(-(2/3)z^(3/2)))/2/
  mpf_div(tmp, zh1s4, Ai);                // Ai = (e^(-(2/3)z^(3/2)))/2//z^(1/4)

  mpf_exp(n2s3z3s2, ehmzh3s2);            // e^((2/3)z^(3/2))
  mpf_div(ehmzh3s2, rpi, tmp);            // (e^((2/3)z^(3/2)))/
  mpf_div(tmp, zh1s4, Bi);                // Bi = (e^((2/3)z^(3/2)))//z^(1/4)

  mpf_clear4(zh3s2, zh1s4, ehmzh3s2, tmp);
  mpf_clear2(rpi, n2s3z3s2);
end;

// Power_series_ Airy֐ {
// z   l
procedure  Airy_functions(z : mp_float; var Ai, Bi : mp_float);
Label
  EXT;
var
  n : integer;
  sz3np, sz3n, z3n, tmp, sz3b: mp_float;
  zh3, five, six : mp_float;
  p323, g23, p316 : mp_float;
begin
  mpf_init5(sz3np, sz3n, z3n, tmp, sz3b);
  mpf_init3(zh3, five, six);
  mpf_init3(p323, g23, p316);

  mpf_add(two, four, six);          // 6
  // z = 0 ̂̃[`͖Ă 0̌vZ𑬂
  if mpf_is0(z) then begin
    mpf_div(two, three, tmp);
    mpf_expt(three, tmp, p323);     // 3^(2/3)
    gammaMul(tmp, g23);             // (2/3)
    mpf_div(one, p323, Ai);         // 1/3^(2/3)
    mpf_div(Ai, g23, Ai);           // Ai=1/3^(2/3)/(2/3)

    mpf_div(one, six, tmp);         // 1/6
    mpf_expt(three, tmp, p316);     // 3^(1/6)
    mpf_div(one, p316, Bi);         // 1/3^(1/6)
    mpf_div(Bi, g23, Bi);           // Bi=1/3^(1/6)/(2/3);
    goto EXT;
  end;

  mpf_add(one, four, five);                   // 5

  mpf_mul(z, z, zh3);                         // z * z
  mpf_mul(zh3, z, zh3);                       // z * z * z
  mpf_set1(z3n);                              // z^3n
  mpf_set0(sz3n);                             // =0
  mpf_set0(sz3b);
  for n := 0 to KMmax do begin
    mpf_div(z3n, MVG[n], tmp);                // (z^3n)/(n!(n+2/3)*3^(2n)
    mpf_add(sz3n, tmp, sz3n);                 // m
    mpf_sub(sz3n, sz3b, tmp);                 // m- back
    if mpf_is0(tmp) then break;
    mpf_copy(sz3n, sz3b);
    mpf_mul(z3n, zh3, z3n);                   // z^(3n)
  end;

  mpf_set1(z3n);                              // z^3n
  mpf_set0(sz3np);                            // p=0
  mpf_set0(sz3b);
  for n := 0 to KMmax do begin
    mpf_div(z3n, PVG[n], tmp);                // (z^3n)/(n!(n+4/3)*3^(2n)
    mpf_add(sz3np, tmp, sz3np);               // p
    mpf_sub(sz3np, sz3b, tmp);                // p- back
    if mpf_is0(tmp) then break;
    mpf_copy(sz3np, sz3b);
    mpf_mul(z3n, zh3, z3n);                   // z^(3n)
  end;
  mpf_mul(sz3np, z, sz3np);                   // p

  mpf_div(two, three, tmp);                   // 2/3
  mpf_expt(three, tmp, tmp);                  // 3^(2/3)
  mpf_div(sz3n, tmp, Ai);                     // m / (3^(2/3))

  mpf_div(four, three, tmp);                  // 4/3
  mpf_expt(three, tmp, tmp);                  // 3^(4/3)
  mpf_div(sz3np, tmp, tmp);                   // p / (3^(4/3))
  mpf_sub(Ai, tmp, Ai);                       // Ai

  mpf_div(one, six, tmp);                     // 1/6
  mpf_expt(three, tmp, tmp);                  // 3^(1/6)
  mpf_div(sz3n, tmp, Bi);                     // m / (3^(1/6))

  mpf_div(five, six, tmp);                    // 5/6
  mpf_expt(three, tmp, tmp);                  // 3^(5/6)
  mpf_div(sz3np, tmp, tmp);                   // p / (3^(5/6))
  mpf_add(Bi, tmp, Bi);                       // Bi

EXT:
  mpf_clear5(sz3np, sz3n, z3n, tmp, sz3b);
  mpf_clear3(zh3, five, six);
  mpf_clear3(p323, g23, p316);
end;

// x ͒lE
// XinMIN <= xin <= XinMAX  ͈͊Ȍꍇ덷傫Ȃ܂B
// 덷Ȃׂɂ́AZƁAl̏kmax xk[Cp NBl傫
// KvL܂A܏ꍇŏ̔z̏̎ԂȂ܂B
const
  XinMIN = -80;
  XinMAX = 50;
  N = 400;

// vZ
// x̒l傫Ȃƌ덷傫Ȃ܂B
// ta[]OtpvZ_
procedure TForm1.Button1Click(Sender: TObject);
label
  EXT;
const
  CHA = -4;
var
  ch, i : integer;
  xin : double;
  xmin, xmax, dx, xg : double;
  xf, xm, Ai, Bi : mp_float;
begin
  memo1.Clear;
  memo1.Font.Size := 11;
  val(labelededit2.Text, xin, ch);
  if ch <> 0 then begin
    application.MessageBox('x̒lɊԈႢ܂B','', 0);
    exit;
  end;
  if xin < XinMIN then begin
    application.MessageBox(PWideChar('x̐Βl' + floatTostr(XinMIN) + '傫ĉB'),'', 0);
    exit;
  end;
  if XinMAX > XinMax then begin
    application.MessageBox(PWideChar('x̐Βl' + floatTostr(XinMAX) + '菬ĉB'),'', 0);
    exit;
  end;

  mpf_init4(xf, xm, Ai, Bi);

  application.ProcessMessages;

  mpf_read_decimal(xm, PAnsiChar(ansistring(labelededit2.Text + #00)));

  memo1.Clear;

  Airy_functions(xm, Ai, Bi);

  memo1.Lines.Append('ʃGA[֐');
  memo1.Lines.Append( string('Ai(x) = ' + mpf_decimal(Ai, 50)));
  memo1.Lines.Append( string('Bi(x) = ' + mpf_decimal(Bi, 50)));

  series1.Clear;
  series2.Clear;
  series3.Clear;
  series4.Clear;
  if checkbox1.Checked = false then begin          // OtI
    series1.Clear;
    series2.Clear;
    application.ProcessMessages;
    Chart1.Canvas.Font.Style := [fsBold];
    Chart1.Canvas.Font.size := 8;
    Chart1.Canvas.TextOut(180, 130,'Ot');
    goto EXT;
  end
  else begin
    application.ProcessMessages;
    Chart1.Canvas.Font.Style := [fsBold];
    Chart1.Canvas.Font.size := 8;
    Chart1.Canvas.TextOut(170, 130,'Ot쐬');
    application.ProcessMessages;
  end;

// Ot\

  series3.AddXY(xin, mpf_todouble(Ai));
  series4.AddXY(xin, mpf_todouble(Bi));

  xmin := round(xin) - 8;
  xmax := xmin + 13;
  dx := (xmax - xmin) / N;
  for i := 0 to N do begin
    xg := dx * i + xmin;
    mpf_set_dbl(xf, xg);

    if xg > abs(CHA) then AiryL_functions(xf, Ai, Bi)
    else
      if xg < CHA then AiryS_functions(xf, Ai, Bi)
      else
        Airy_functions(xf, Ai, Bi);

    series1.AddXY(xg, mpf_todouble(Ai));
    series2.AddXY(xg, mpf_todouble(Bi));
  end;
  application.ProcessMessages;

EXT:
  mpf_clear4(xf, xm, Ai, Bi);
end;

// ݒ
// vZpz񏀔
// Z͈̔͂LׂɂKmax̒lAxk[CNoAZ傫KvL܂B
// Ɏ傫ꍇkmaxAZ傫Kv܂B
// 傫ƔgZȂ胢xKv܂B
// Z͈̔͂LƃOt\̎ԂɒȂ܂B
procedure TForm1.Setting;
var
  i, k : integer;
  N, D, tmp : mp_float;
  v,  vk, k3h2n, nine: mp_float;
begin
  mpf_set_default_decprec(300);         // L300 50̐xɕKvłB
  setlength(BM, NB + 1);                // xk[Cz
  setlength(FA, KMmax + 1);             // K!z
  setlength(PVG, KMmax + 1);            // +v
  setlength(MVG, KMmax + 1);            // +v

  for i := 0 to NB do mpf_init(BM[i]);
  for i := 0 to KMmax do mpf_init(FA[i]);
  for i := 0 to KMmax do mpf_init(PVG[i]);
  for i := 0 to KMmax do mpf_init(MVG[i]);

  mpf_init3(N, D, tmp);
  mpf_init4(zero, one, two, four);
  mpf_init3(three, pai, log_2pis2);
  mpf_init4(v, vk, k3h2n, nine);

  mpf_set0(zero);
  mpf_set1(one);
  mpf_set_int(two, 2);
  mpf_set_int(three, 3);
  mpf_set_int(four, 4);
  mpf_set_pi(pai);

  mpf_mul(pai, two, tmp);          // 2
  mpf_ln(tmp, tmp);                // ln(2)
  mpf_div(tmp, two, log_2pis2);    // ln(2)/2

  Bernoulli_number_BigInteger;              //  xk[C쐬

  for i := 0 to NB do begin
    mpf_read_decimal(N, PAnsiChar(ansistring(NumeratorString[i] + #00)));
    mpf_read_decimal(D, PAnsiChar(ansistring(DenominatorString[i] + #00)));
    mpf_div(N, D, BM[i]);
  end;

  factorialMul(kMmax);                      // 0!`KMmax!

  mpf_set1(k3h2n);                          // 3^(2n) k = 0 ̎ 1
  mpf_set_int(nine, 9);                     // 3 * 3
  mpf_div(four, three, v);                  // v 4/3
  for k := 0 to KMmax do begin
    mpf_add_int(v , k, vk);                 // v + k
    gammaMul(vk, tmp);                      // (n+k)
    mpf_mul(tmp, k3h2n, tmp);               // (n+k) * 3^(2n)
    mpf_mul(tmp, FA[k], PVG[k]);            // n! * (n+k) * 3^(2n)
    mpf_mul(k3h2n, nine, k3h2n);            // 3^(2n)
  end;

  mpf_set1(k3h2n);                          // 3^(2n) k = 0 ̎ 1
  mpf_div(two, three, v);                   // v 2/3
  for k := 0 to KMmax do begin
    mpf_add_int(v , k, vk);                 // v + k
    gammaMul(vk, tmp);                      // (n+k)
    mpf_mul(tmp, k3h2n, tmp);               // (n+k) * 3^(2n)
    mpf_mul(tmp, FA[k], MVG[k]);            // n! * (n+k) * 3^(2n)
    mpf_mul(k3h2n, nine, k3h2n);            // 3^(2n)
  end;

  memo1.Clear;
  memo1.Font.Color := clBlack;
  memo1.Lines.Append('');
  memo1.Lines.Append('             ');
  Labelededit2.EditLabel.Caption := 'x (' + floattostr(XinMIN) + 'x' + floattostr(XinMAX) + ')';

  Button1.Enabled := True;

  mpf_clear3(N, D, tmp);
  mpf_clear4(v, vk, k3h2n, nine);
end;

// X^[g\
procedure TForm1.FormCreate(Sender: TObject);
begin
  Button1.Enabled := False;
  memo1.Clear;
  memo1.Font.Size := 18;
  memo1.Font.Color := clRed;
  memo1.Lines.Append('');
  memo1.Lines.Append('             vZpz񏀔');
  Timer1.Interval := 200;
  Timer1.Enabled := True;
end;

//
procedure TForm1.Timer1Timer(Sender: TObject);
begin
  Timer1.Enabled := False;
  Setting;
end;

// I
procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var
  i : integer;
begin
  for i := 0 to NB do mpf_clear(BM[i]);
  for i := 0 to KMmax do mpf_clear(FA[i]);
  for i := 0 to KMmax do mpf_clear(PVG[i]);
  for i := 0 to KMmax do mpf_clear(MVG[i]);
  mpf_clear4(zero, one, two, four);
  mpf_clear3(three, pai, log_2pis2);
end;

end.
