unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls,
  VclTee.TeeGDIPlus, VCLTee.TeEngine, VCLTee.Series, VCLTee.TeeProcs,
  VCLTee.Chart, System.Diagnostics;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    LabeledEdit2: TLabeledEdit;
    Chart1: TChart;
    Series1: TLineSeries;
    Series2: TLineSeries;
    Series3: TPointSeries;
    Series4: TPointSeries;
    CheckBox1: TCheckBox;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

uses system.Math, System.VarCmplx, Velthuis.BigIntegers,mp_real, mp_cmplx, mp_types, mp_base;

{$R *.dfm}

type
  DArray = array of double;

var
  BM : array of mp_float;       // xk[Cz

  zero, one, two, three  : mp_float;
  four, pai : mp_float;

const
  KMmax = 1000;                  // KM max   1000

//------------------------------------------------------------------------------
  NB = 150;                            // xk[C  z NB + 1

var
  NumeratorString : array[0..NB] of string;               // q
  DenominatorString  : array[0..NB] of string;            // 

  FA : array of mp_float;       // Kz

// ő  [Nbȟݏ@ BigInteger
function gcd_BigInteger(x, y: BigInteger): BigInteger;
var
  t : BigInteger;
begin
  while y <> 0 do begin
    t := x mod y;
    x := y;
    y := t;
  end;
  result := x;
end;

// xk[C
// Akiyama-Tanigawa algorithm
// BigInteger
procedure Bernoulli_number_BigInteger;
const
  n = (NB + 1) * 2;
var
  m, j, k : integer;
  a     : array of BigInteger;      // q
  b     : array of BigInteger;      // 
  tmpN  : BigInteger;               // q
  tmpD  : BigInteger;               // 
  gcd   : BigInteger;               // ő
  b0    : BigInteger;
begin
  setlength(a, n + 1);
  setlength(b, n + 1);
  k := 0;
  for m := 0 to n do begin
    a[m] := 1;                         // q l
    b[m] := (m + 1);                                //  l
    for j := m - 1 downto 0 do begin
      tmpN := a[j] * b[j + 1] - a[j + 1] * b[j];    // q
      tmpN := tmpN * (j + 1);                       // V
      tmpD := b[j] * b[j + 1];                      // 
      gcd := gcd_BigInteger(tmpN, tmpD);            // ő
      a[j] := tmpN div gcd;
      b[j] := tmpD div gcd;
    end;
    if (m > 0) and (m mod 2 = 0) then begin
      b0 := b[0];
      b0 := b0 * m * (m -1);                       // m xk[CNo
      NumeratorString[k] := a[0].tostring;
      DenominatorString[k] := b0.tostring;
      inc(k);
    end;
  end;
end;

//------------------------------------------------------------------------------

// OK}{
procedure log_GammaMul(var x, ans : mp_float);
var
  v, w , log_2pis2: mp_float;
  tmp, tmp0, s : mp_float;
  i : integer;
begin
  mpf_init3(v, w, log_2pis2);
  mpf_init3(tmp, tmp0, s);

  mpf_set_pi(tmp);                  // 
  mpf_add(tmp, tmp, tmp0);          // 2
  mpf_ln(tmp0, tmp);                // ln(2)
  mpf_div(tmp, two, log_2pis2);     // ln(2)/2

  mpf_set1(v);
  mpf_set_int(tmp, NB);
  while mpf_is_lt(x, tmp) do begin
    mpf_mul(v, x, v);
    mpf_add(x, one, x);
  end;
  mpf_mul(x, x, tmp);               // x^2
  mpf_div(one, tmp, w);             // w = 1 / x^2
  mpf_set0(s);
  for i := NB downto 1 do begin
    mpf_add(s, BM[i], tmp);         // tmp = s + B[i]
    mpf_mul(tmp, w, s);             // s = tmp * w
  end;
  mpf_add(s, BM[0], tmp);           // tmp = s + B[0]
  mpf_div(tmp, x, s);               // s = (s + B[0]) / x
  mpf_add(s, log_2pis2, s);         // s = s + ln(2)/2
  mpf_ln(v, tmp);                   // ln(v)
  mpf_sub(s, tmp, s);               // s := s - ln(v)
  mpf_sub(s, x, s);                 // s := s - x
  mpf_div(one, two, tmp);           // tmp = 1/2
  mpf_sub(x, tmp, tmp0);            // tmp0 = x - 1/2
  mpf_ln(x, tmp);                   // ln(x)
  mpf_mul(tmp0, tmp, tmp0);         // tmp0 = (x - 1/2) * ln(x)
  mpf_add(s, tmp0, ans);            // ans = s + (x - 1/2) * ln(x)

  mpf_clear3(v, w, log_2pis2);
  mpf_clear3(tmp, tmp0, s);
end;

// {K}
// x̒l 0 ƕ̎́ɂȂ̂łĂ܂̂ŃG[ɂȂ܂B
procedure gammaMul(var x, ans: mp_float);
var
  tmp, tmp0, logG, pai : mp_float;
begin
  mpf_init4(tmp, tmp0, logG, pai);

  mpf_set_pi(pai);
  if mpf_is_lt(x, zero) then begin
    mpf_mul(pai, x, tmp);            // x*
    mpf_sin(tmp, tmp0);              // sin(x);
    mpf_sub(one, x, tmp);            // 1-x
    log_GammaMul(tmp, logG);         // loggamma(1-x);
    mpf_exp(logG, logG);             // exp(logG)
    mpf_div(pai, tmp0, tmp);         // /sin(x)
    mpf_div(tmp, logG, ans);         // ans = /(sin(x) * logG(1-x))
  end
  else begin
    log_GammaMul(x, logG);           // logG
    mpf_exp(logG, ans);              // exp(logG)
  end;

  mpf_clear4(tmp, tmp0, logG, pai);
end;

// K {
procedure factorialMul(n : integer);
label
  EXT;
var
  i : integer;
  bi, ans : mp_float;
begin
  mpf_init2(bi, ans);

  mpf_set1(ans);
  mpf_copy(ans, FA[0]);
  mpf_copy(ans, FA[1]);

  mpf_copy(two, bi);

  if n <= 1 then begin
    goto EXT;
  end;
  for i := 2 to n do  begin
    mpf_mul(ans, bi, ans);
    mpf_copy(ans, FA[i]);
    mpf_add(bi, one, bi);
  end;
EXT:
  mpf_clear2(bi, ans);
end;

//------------------------------------------------------------------------------

// }N[WJA _u
procedure AiryA_double(x : double; var Ai, Bi : double);
var
  n : integer;
  s0, s1, sb: double;
  s23, s34 : double;
  xh3, sxh3 : double;
begin
  s0 := 0;                            // 0
  sb := 0;                            // 0
  xh3 := x * x * x;                   // x^3
  sxh3 := xh3;
  s23 := 1;                           // 1
  for n := 1 to 100 do begin
    s23 := s23 * (3 * n - 1) * (3 * n);   // (2,3),(5,6),,,((3n-1) * 3n)
    s0 := s0 + sxh3 / s23;            // s0 := s0 + (x^3)/((2,3),(5,6),,,)((3n-1) * 3n))
    if s0 = sb then break;
    sxh3 := sxh3 * xh3;
    sb := s0;
  end;
  s0 := s0 + 1;

  s1 := 0;
  sb := 0;
  sxh3 := xh3;                        // x^3
  s34 := 1;
  for n := 1 to 100 do begin
    s34 := s34 * (3 * n) * (3 * n + 1);   // (3,4),(6,7),,,(3n * (3n+1))
    s1 := s1 + sxh3 / s34;            // s1 := s1 + (x^3n)/((3,4),(6,7),,,(3n * (3n+1)))
    if s1 = sb then break;
    sxh3 := sxh3 * xh3;
    sb := s1;
  end;
  s1 := s1 * x + x;

  Ai := s0 * 3.55028053887817239260063186E-1;
  Ai := Ai + s1 * -2.588194037928067984051835601E-1;
  Bi := s0 * 6.1492662744600073515092236909E-1;
  Bi := Bi + s1 * 4.4828835735382635791482371039E-1;
end;

// }N[WJ  double
procedure Airy_double(x : double; var Ai, Bi : double);
var
  k : integer;
  x3hk, xh3 : double;
  k3p1, k3p2 : double;
  k3 : double;
  s0, s1, sd : double;
  Ai0, Aid : double;
  Bi0, Bid : double;
begin
  xh3 := x * x * x;                       // x^3
  s0 := 1;                                // k=0 l
  sd := 0;                                // backup
  x3hk := 1;                              // x^(3k)
  k3p1 := 1;                              // (3k+1)
  k3 := 1;                                // (3k+1)!
  for k := 1 to 100 do begin
    x3hk := x3hk * xh3;                   // x^(3k);
    k3 := k3 * (3 * k - 1) * (3 * k) * (3 * k + 1);  // (3k+1)!
    k3p1 := k3P1 * (3 * k + 1);           // 1.4.7.(3k+1)
    s0 := s0 + k3p1 / k3 * x3hk;
    if s0 = sd then break;
    sd := s0;
  end;

  s1 := 1;                                // K=0 l
  sd := 0;                                // backup
  x3hk := 1;                              // x^(3k)
  k3p2 := 2;                              // 2
  k3 :=   2;                              // 2
  for k := 1 to 100 do begin
    x3hk := x3hk * xh3;                   // x^(3k)
    k3  := k3 * (3 * k) * (3 * k + 1) * (3 * k + 2);     // (3k+2)!
    k3p2 := k3P2 * (3 * k + 2);           // 2.5.8.(3k+2)
    s1 := s1 + k3p2 / k3 * x3hk;
    if s1 = sd then break;
    sd := s1;
  end;
  s1 := s1 * x;                             // x   x^(3k+1)

  Ai0 := s0 * 3.55028053887817239260063186E-1;
  Aid := s1 * -2.588194037928067984051835601E-1;

  Ai := Ai0 + Aid;

  Bi0 := s0 * 6.1492662744600073515092236909E-1;
  Bid := s1 * 4.4828835735382635791482371039E-1;

  Bi := Bi0 + Bid;
end;

// z̒l z < 0 ̎OtpɋߎlvZ
procedure AiryS_functions(z : mp_float; var Ai, Bi : mp_float);
var
  zh3s2, pis4, zh1s4, rpi, tmp : mp_float;
  n23zppi4, sincos, az : mp_float;
begin
  mpf_init5(zh3s2, pis4, zh1s4, rpi, tmp);
  mpf_init3(n23zppi4, sincos, az);

  mpf_abs(z, az);                             // |Z|

  mpf_div(one, four, tmp);                    // 1/4
  mpf_expt(az, tmp, zh1s4);                   // z^(1/4)
  mpf_sqrt(pai, rpi);                         // 
  mpf_div(pai, four, pis4);                   // /4
  mpf_div(three, two, tmp);                   // 3/2
  mpf_expt(az, tmp, zh3s2);                   // z^(3/2)
  mpf_mul(zh3s2, two, tmp);                   // 2(z^(3/2))
  mpf_div(tmp, three, tmp);                   // 2/3((z^(3/2)))
  mpf_add(tmp, pis4, n23zppi4);               // 2/3((z^(3/2))) + /4
  mpf_sin(n23zppi4, sincos);                  // sin(2/3((z^(3/2))) + /4)
  mpf_div(sincos, rpi, tmp);                  // sin/
  mpf_div(tmp, zh1s4, Ai);                    // sin//z^(1/4)

  mpf_cos(n23zppi4, sincos);                  // cos(2/3((z^(3/2))) + /4)
  mpf_div(sincos, rpi, tmp);                  // cos/
  mpf_div(tmp, zh1s4, Bi);                    // cos//z^(1/4)

  mpf_clear5(zh3s2, pis4, zh1s4, rpi, tmp);
  mpf_clear3(n23zppi4, sincos, az);
end;

// z̒l z > 0 ̎OtpɋߎlvZ
procedure AiryL_functions(z : mp_float; var Ai, Bi : mp_float);
var
  zh3s2, zh1s4, ehmzh3s2, tmp : mp_float;
  rpi, n2s3z3s2: mp_float;
begin
  mpf_init4(zh3s2, zh1s4, ehmzh3s2, tmp);
  mpf_init2(rpi, n2s3z3s2);

  mpf_div(three, two, tmp);               // 3/2
  mpf_expt(z, tmp, zh3s2);                // z^(3/2)
  mpf_mul(zh3s2, two, tmp);               // 2z^(3/2)
  mpf_div(tmp, three, n2s3z3s2);          // (2/3)z^(3/2)
  mpf_chs(n2s3z3s2, tmp);                 // -(2/3)z^(3/2)
  mpf_exp(tmp, ehmzh3s2);                 // e^(-(2/3)z^(3/2))
  mpf_div(one, four, tmp);                // 1/4
  mpf_expt(z, tmp, zh1s4);                // z^(1/4)
  mpf_sqrt(pai, rpi);                     // 
  mpf_div(ehmzh3s2, two, tmp);            // (e^(-(2/3)z^(3/2)))/2
  mpf_div(tmp, rpi, tmp);                 // (e^(-(2/3)z^(3/2)))/2/
  mpf_div(tmp, zh1s4, Ai);                // Ai = (e^(-(2/3)z^(3/2)))/2//z^(1/4)

  mpf_exp(n2s3z3s2, ehmzh3s2);            // e^((2/3)z^(3/2))
  mpf_div(ehmzh3s2, rpi, tmp);            // (e^((2/3)z^(3/2)))/
  mpf_div(tmp, zh1s4, Bi);                // Bi = (e^((2/3)z^(3/2)))//z^(1/4)

  mpf_clear4(zh3s2, zh1s4, ehmzh3s2, tmp);
  mpf_clear2(rpi, n2s3z3s2);
end;

// {vZ }N[WJ
procedure Airy_functions(z : mp_float; var Ai, Bi : mp_float);
var
  k, n3kp : integer;
  s313, g13, s323, g23, s316 : mp_float;
  Aid, Bid, Ais, Bis , tmp : mp_float;
  zh3, s0, s1, sd, k3 : mp_float;
  x3hk, k3p1, k3p2, tmf : mp_float;
  Ai0, Bi0 : mp_float;
begin
  mpf_init5(s313, g13, s323, g23, s316) ;
  mpf_init5(Aid, Bid, Ais, Bis, tmp);
  mpf_init5(zh3, s0, s1, sd, k3);
  mpf_init5(x3hk, k3p1, tmf, Ai0, Bi0);
  mpf_init(k3p2);

  mpf_div(one, three, tmp);           // 1/3
  mpf_expt(three, tmp, s313);         // 3^(1/3)
  gammaMul(tmp, g13);                 // (1/3)

  mpf_div(two, three, tmp);           // 2/3
  mpf_expt(three, tmp, s323);         // 3^(2/3)
  gammaMul(tmp, g23);                 // (2/3)

  mpf_div(one, two, tmp);             // 1/2
  mpf_div(tmp, three, tmp);           // 1/6
  mpf_expt(three, tmp, s316);         // 3^(1/6);

  mpf_mul(s323, g23, tmp);            // 3^(2/3) * (2/3)
  mpf_div(one, tmp, Ai0);             // Ai0 = 1 / 3^(2/3) / (2/3)

  mpf_mul(s313, g13, tmp);            // 3^(1/3) * (1/3)
  mpf_div(one, tmp, Aid);             // Ai'0 = 1 / 3^(1/3) / (1/3)
  mpf_chs(Aid, Aid);

  mpf_mul(s316, g23, tmp);            // 3^(1/6) * (2/3)
  mpf_div(one, tmp, Bi0);             // Bi0 = 1 / 3^(1/6) * (2/3)

  mpf_div(s316, g13, Bid);            // Bi'0  = 3^(1/6) / (1/3);

  mpf_mul(z, z, tmp);                 // z^2
  mpf_mul(tmp, z, zh3);               // z^3

  mpf_set0(s0);                       // k = 0 l
  mpf_set0(sd);                       // backup
  mpf_set1(x3hk);                     // z^(3k)
  mpf_set1(k3p1);                     // 3k+1
  mpf_set1(k3);                       // 3k+1

  for k := 0 to KMmax do begin
    mpf_mul_int(three, k, tmp);       // 3k
    mpf_add(tmp, one, k3p1);          // 3k + 1
    mpf_mul(k3, k3p1, k3);            // 1.4.7..(3k+1)
    n3kp := (3 * k + 1);              // 3k + 1
    mpf_div(k3, FA[n3kp], tmp);       // 1.4.7..(3k+1)/(3k+1)!
    mpf_mul(tmp, x3hk, tmf);          // 1.4.7..(3k+1)/(3k+1)! * Z^(3k)
    mpf_add(s0, tmf, s0);             // 
    if mpf_is_eq(s0, sd) then break;
    mpf_copy(s0, sd);
    mpf_mul(x3hk, zh3, x3hk);         // (z^(3^k)
  end;

  mpf_set0(s1);                       // k=0 l
  mpf_set0(sd);                       // backup
  mpf_set1(x3hk);                     // z^(3k)
  mpf_set1(k3p2);                     // 1
  mpf_set1(k3);                       // 1
  for k := 0 to KMmax do begin
    mpf_mul_int(three, k, tmp);       // 3k
    mpf_add(tmp, two, k3P2);          // 3k + 2
    mpf_mul(k3, k3p2, k3);            // 2.5.8..(3k+2)
    n3kp := (3 * k + 2);              // 3k + 2
    mpf_div(k3, FA[n3kp], tmp);       // 2.5.8..(3k+2)/(3k+2)!
    mpf_mul(tmp, x3hk, tmf);          // 2.5.8..(3k+2)/(3k+2)! * z^(3k)
    mpf_add(s1, tmf, s1);             // 
    if mpf_is_eq(s1, sd) then break;
    mpf_copy(s1, sd);
    mpf_mul(x3hk, zh3, x3hk);         // (z^(3^k)
  end;
  mpf_mul(s1, z, s1);                 // z^(3k+1)

  mpf_mul(s0, Ai0, Ais);              // Ais = 0 * Ai(0)
  mpf_mul(s1, Aid, tmf);              // 1 * Ai'(0)
  mpf_add(tmf, Ais, Ai);              // Ai

  mpf_mul(s0, Bi0, Bis);              // Bis = 0 * Bi(0)
  mpf_mul(s1, bid, tmp);              // 1 * Bi'(0)
  mpf_add(tmp, Bis, Bi);              // Bi

  mpf_clear5(s313, g13, s323, g23, s316) ;
  mpf_clear5(Aid, Bid, Ais, Bis, tmp);
  mpf_clear5(zh3, s0, s1, sd, k3);
  mpf_clear5(x3hk, k3p1, tmf, Ai0, Bi0);
  mpf_clear(k3p2);
end;
//------------------------------------------------------------------------------

const
  XinMIN = -65;
  XinMAX = 40;

// vZ
// x̒l傫Ȃƌ덷傫Ȃ܂B
// ta[]OtpvZ_
procedure TForm1.Button1Click(Sender: TObject);
label
  EXT;
const
  N = 200;
  XLIM = -2;
var
  ch, i : integer;
  xin : double;
  xmin, xmax, dx, xg : double;
  xf, xm, Ai, Bi : mp_float;
  AiD, Bid : double;
begin
  memo1.Clear;
  memo1.Font.Size := 11;
  val(labelededit2.Text, xin, ch);
  if ch <> 0 then begin
    application.MessageBox('x̒lɊԈႢ܂B','', 0);
    exit;
  end;

  if xin < XinMIN then begin
    application.MessageBox(pwidechar('x̐Βl' + intTostr(XinMIN) + '傫ĉB'),'', 0);
    exit;
  end;
  if xin > XinMAX then begin
    application.MessageBox(pwidechar('x̐Βl' + intTostr(XinMax) + '菬ĉB'),'', 0);
    exit;
  end;

  mpf_init4(xf, xm, Ai, Bi);

  series1.Clear;
  series2.Clear;
  series3.Clear;
  series4.Clear;

  application.ProcessMessages;

  mpf_read_decimal(xm, PAnsiChar(ansistring(labelededit2.Text + #00)));

  memo1.Lines.Append('GA[֐ power series');

  if (xin <= 3) and (xin >= -8) then begin
    memo1.Lines.Append(' double Z');
    Airy_double(xin, Aid, Bid);
    memo1.Lines.Append('Z 1    Ai(x) = ' + floattostr(Aid));
    memo1.Lines.Append('@@@      Bi(x) = ' + floattostr(Bid));
    AiryA_double(xin, Aid, Bid);
    memo1.Lines.Append('Z 2    Ai(x) = ' + floattostr(Aid));
    memo1.Lines.Append('            Bi(x) = ' + floattostr(Bid));
  end;

  Airy_functions(xm, Ai, Bi);

  memo1.Lines.Append( string('Ai(x) = ' + mpf_decimal(Ai, 50)));
  memo1.Lines.Append( string('Bi(x) = ' + mpf_decimal(Bi, 50)));

  if checkbox1.Checked = false then begin          // OtI
      Chart1.Canvas.Font.Style := [fsBold];
      Chart1.Canvas.Font.size := 8;
      Chart1.Canvas.TextOut(170, 115,'Ot');
    goto EXT;
  end;

// Ot\
  series3.AddXY(xin, mpf_todouble(Ai));
  series4.AddXY(xin, mpf_todouble(Bi));
  xmin := round(xin) - 8;
  xmax := xmin + 13;
  dx := (xmax - xmin) / N;
  for i := 0 to N do begin
    xg := dx * i + xmin;
    mpf_set_dbl(xf, xg);

    if xg > abs(XLIM) then AiryL_functions(xf, Ai, Bi)
    else
      if xg < XLIM then AiryS_functions(xf, Ai, Bi)
      else
        Airy_functions(xf, Ai, Bi);

    series1.AddXY(xg, mpf_todouble(Ai));
    series2.AddXY(xg, mpf_todouble(Bi));
  end;

  application.ProcessMessages;
EXT:
  mpf_clear4(xf, xm, Ai, Bi);
end;

// ݒ
// X^[g\
procedure TForm1.FormCreate(Sender: TObject);
var
  i : integer;
  N, D : mp_float;
begin
  mpf_set_default_decprec(200);         // L200 50̐xɕKvłB
  setlength(BM, NB + 1);                // xk[Cz
  setlength(FA, 3 * KMmax + 3);

  for i := 0 to NB do mpf_init(BM[i]);
  for i := 0 to 3 * KMmax + 2 do mpf_init(FA[i]);

  mpf_init2(N, D);
  mpf_init4(zero, one, two, three);
  mpf_init2(four, pai);

  mpf_set0(zero);
  mpf_set1(one);
  mpf_set_int(two, 2);
  mpf_set_int(three, 3);
  mpf_set_int(four, 4);
  mpf_set_pi(pai);

  Bernoulli_number_BigInteger;              //  xk[C쐬

  for i := 0 to NB do begin
    mpf_read_decimal(N, PAnsiChar(ansistring(NumeratorString[i] + #00)));
    mpf_read_decimal(D, PAnsiChar(ansistring(DenominatorString[i] + #00)));
    mpf_div(N, D, BM[i]);
  end;

  factorialMul(3 * KMmax + 2);                      // 0!`KMmax!

  Labelededit2.EditLabel.Caption := 'x (' + inttostr(XinMIN) + 'x' + inttostr(XinMAX) + ')';

  memo1.Clear;
  mpf_clear2(N, D);
end;

// I
procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var
  i : integer;
begin
  for i := 0 to NB do mpf_clear(BM[i]);
  for i := 0 to  3 * KMmax + 2  do mpf_clear(FA[i]);
  mpf_clear4(zero, one, two, three);
  mpf_clear2(four, pai);
end;

end.
