unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls,
  VclTee.TeeGDIPlus, VCLTee.TeEngine, VCLTee.Series, VCLTee.TeeProcs,
  VCLTee.Chart, System.Diagnostics, System.StrUtils;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    LabeledEdit2: TLabeledEdit;
    Chart1: TChart;
    Series1: TLineSeries;
    Series2: TLineSeries;
    Series3: TPointSeries;
    Series4: TPointSeries;
    CheckBox1: TCheckBox;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

uses system.Math, Velthuis.BigIntegers, Velthuis.BigDecimals,
                        mp_real, mp_cmplx, mp_types, mp_base;

{$R *.dfm}


const
  KMmax = 2000;                  // KM max   1000

var
  zero, one, two, four : mp_float;
  three, pai : mp_float;


//------------------------------------------------------------------------------
const
  ai0d =  3.55028053887817239260063186E-1;
  aidd = -2.588194037928067984051835601E-1;
  bi0d =  6.1492662744600073515092236909E-1;
  bidd =  4.4828835735382635791482371039E-1;

// }N[WJA _u
procedure AiryA_double(x : double; var Ai, Bi : double);
var
  n : integer;
  s0, s1, sb: double;
  s23, s34 : double;
  xh3, sxh3 : double;
begin
  s0 := 0;                            // 0
  sb := 0;                            // 0
  xh3 := x * x * x;                   // x^3
  sxh3 := xh3;
  s23 := 1;                           // 1
  for n := 1 to 100 do begin
    s23 := s23 * (3 * n - 1) * (3 * n);   // (2,3),(5,6),,,((3n-1) * 3n)
    s0 := s0 + sxh3 / s23;            // s0 := s0 + (x^3)/((2,3),(5,6),,,)((3n-1) * 3n))
    if s0 = sb then break;
    sxh3 := sxh3 * xh3;
    sb := s0;
  end;
  s0 := s0 + 1;

  s1 := 0;
  sb := 0;
  sxh3 := xh3;                        // x^3
  s34 := 1;
  for n := 1 to 100 do begin
    s34 := s34 * (3 * n) * (3 * n + 1);   // (3,4),(6,7),,,(3n * (3n+1))
    s1 := s1 + sxh3 / s34;            // s1 := s1 + (x^3n)/((3,4),(6,7),,,(3n * (3n+1)))
    if s1 = sb then break;
    sxh3 := sxh3 * xh3;
    sb := s1;
  end;
  s1 := s1 * x + x;

  Ai := s0 * ai0d;
  Ai := Ai + s1 * aidd;
  Bi := s0 * bi0d;
  Bi := Bi + s1 * bidd;
end;

// }N[WJ  double
procedure Airy_double(x : double; var Ai, Bi : double);
var
  k : integer;
  x3hk, xh3 : double;
  k3p1, k3p2 : double;
  k3 : double;
  s0, s1, sd : double;
  Ai0, Aid : double;
  Bi0, Bid : double;
begin
  xh3 := x * x * x;                       // x^3
  s0 := 1;                                // k=0 l
  sd := 0;                                // backup
  x3hk := 1;                              // x^(3k)
  k3p1 := 1;                              // (3k+1)
  k3 := 1;                                // (3k+1)!
  for k := 1 to 100 do begin
    x3hk := x3hk * xh3;                   // x^(3k);
    k3 := k3 * (3 * k - 1) * (3 * k) * (3 * k + 1);  // (3k+1)!
    k3p1 := k3P1 * (3 * k + 1);           // 1.4.7.(3k+1)
    s0 := s0 + k3p1 / k3 * x3hk;
    if s0 = sd then break;
    sd := s0;
  end;

  s1 := 1;                                // K=0 l
  sd := 0;                                // backup
  x3hk := 1;                              // x^(3k)
  k3p2 := 2;                              // 2
  k3 :=   2;                              // 2
  for k := 1 to 100 do begin
    x3hk := x3hk * xh3;                   // x^(3k)
    k3  := k3 * (3 * k) * (3 * k + 1) * (3 * k + 2);     // (3k+2)!
    k3p2 := k3P2 * (3 * k + 2);           // 2.5.8.(3k+2)
    s1 := s1 + k3p2 / k3 * x3hk;
    if s1 = sd then break;
    sd := s1;
  end;
  s1 := s1 * x;                             // x   x^(3k+1)

  Ai0 := s0 * ai0d;
  Aid := s1 * aidd;

  Ai := Ai0 + Aid;

  Bi0 := s0 * bi0d;
  Bid := s1 * bidd;

  Bi := Bi0 + Bid;
end;

// z̒l z < 0 ̎OtpɋߎlvZ
procedure AiryS_functions(z : mp_float; var Ai, Bi : mp_float);
var
  zh3s2, pis4, zh1s4, rpi, tmp : mp_float;
  n23zppi4, sincos, az : mp_float;
begin
  mpf_init5(zh3s2, pis4, zh1s4, rpi, tmp);
  mpf_init3(n23zppi4, sincos, az);

  mpf_abs(z, az);                             // |Z|

  mpf_div(one, four, tmp);                    // 1/4
  mpf_expt(az, tmp, zh1s4);                   // z^(1/4)
  mpf_sqrt(pai, rpi);                         // 
  mpf_div(pai, four, pis4);                   // /4
  mpf_div(three, two, tmp);                   // 3/2
  mpf_expt(az, tmp, zh3s2);                   // z^(3/2)
  mpf_mul(zh3s2, two, tmp);                   // 2(z^(3/2))
  mpf_div(tmp, three, tmp);                   // 2/3((z^(3/2)))
  mpf_add(tmp, pis4, n23zppi4);               // 2/3((z^(3/2))) + /4
  mpf_sin(n23zppi4, sincos);                  // sin(2/3((z^(3/2))) + /4)
  mpf_div(sincos, rpi, tmp);                  // sin/
  mpf_div(tmp, zh1s4, Ai);                    // sin//z^(1/4)

  mpf_cos(n23zppi4, sincos);                  // cos(2/3((z^(3/2))) + /4)
  mpf_div(sincos, rpi, tmp);                  // cos/
  mpf_div(tmp, zh1s4, Bi);                    // cos//z^(1/4)

  mpf_clear5(zh3s2, pis4, zh1s4, rpi, tmp);
  mpf_clear3(n23zppi4, sincos, az);
end;

// z̒l z > 0 ̎OtpɋߎlvZ
procedure AiryL_functions(z : mp_float; var Ai, Bi : mp_float);
var
  zh3s2, zh1s4, ehmzh3s2, tmp : mp_float;
  rpi, n2s3z3s2: mp_float;
begin
  mpf_init4(zh3s2, zh1s4, ehmzh3s2, tmp);
  mpf_init2(rpi, n2s3z3s2);

  mpf_div(three, two, tmp);               // 3/2
  mpf_expt(z, tmp, zh3s2);                // z^(3/2)
  mpf_mul(zh3s2, two, tmp);               // 2z^(3/2)
  mpf_div(tmp, three, n2s3z3s2);          // (2/3)z^(3/2)
  mpf_chs(n2s3z3s2, tmp);                 // -(2/3)z^(3/2)
  mpf_exp(tmp, ehmzh3s2);                 // e^(-(2/3)z^(3/2))
  mpf_div(one, four, tmp);                // 1/4
  mpf_expt(z, tmp, zh1s4);                // z^(1/4)
  mpf_sqrt(pai, rpi);                     // 
  mpf_div(ehmzh3s2, two, tmp);            // (e^(-(2/3)z^(3/2)))/2
  mpf_div(tmp, rpi, tmp);                 // (e^(-(2/3)z^(3/2)))/2/
  mpf_div(tmp, zh1s4, Ai);                // Ai = (e^(-(2/3)z^(3/2)))/2//z^(1/4)

  mpf_exp(n2s3z3s2, ehmzh3s2);            // e^((2/3)z^(3/2))
  mpf_div(ehmzh3s2, rpi, tmp);            // (e^((2/3)z^(3/2)))/
  mpf_div(tmp, zh1s4, Bi);                // Bi = (e^((2/3)z^(3/2)))//z^(1/4)

  mpf_clear4(zh3s2, zh1s4, ehmzh3s2, tmp);
  mpf_clear2(rpi, n2s3z3s2);
end;

const
  PRE = 250;                              // Bigdecimal L

// {vZ BigDecimal }N[WJ
procedure Airy_functions(x : Bigdecimal; var Ai, Bi : Bigdecimal);
const
  Ai0S = '3.55028053887817239260063186004183176397979174199177240583326510300810042450126712957174246054040271688420448730349495839758292670446161937E-1';
  AidS ='-2.58819403792806798405183560189203963479091138354934582210001813856102772676790280654196405827275384313371193211789133381275035952167626014E-1';
  Bi0S = '6.14926627446000735150922369093613553594728188648596505040878753014296519305520640529387343345267569240728438782242516724523554227287639109E-1';
  BidS = '4.48288357353826357914823710398828390866226799212262061082808778372330755009780647185046574400736362878496329249031699773802889479552819613E-1';
var
  k : integer;
  s0, s1, sb: Bigdecimal;
  s3kp1, s3kp2, k3p11h, k3p1h, k3p11 : Bigdecimal;
  k3p1, k3p2, kk3p1 : bigdecimal;
  xh3, sxh3, tmp : Bigdecimal;
  ai0, aid, bi0, bid : Bigdecimal;
begin
  s0 := '0';                            // l 0
  sb := '0';                            // 0
  xh3 := x * x * x;                     // x^3
  sxh3 := '1';                          // 1   x^(3k)
  s3kp1 := '1';                         // 1   * 3(k+1)
  k3p1h := '1';                         // 1   (3(k+1))!
  for k := 0 to KMmax do begin
    sxh3 := sxh3 * xh3;                 // x^(3k)
    sxh3 := sxh3.RoundToPrecision(PRE);
    k3P1 := 3 * k + 1;                  // 3k+1
    s3kp1 := s3kp1 * k3P1;              // 1.4.7.(3k + 1);
    s3kp1 := s3kp1.RoundToPrecision(PRE);
    kk3p1 := 3 * (k + 1);               // 3*(k+1);
    k3p1h := k3p1h * (kk3p1 - 2) * (kk3p1 - 1) * (kk3p1); // (3*(k+1))!
    k3p1h := k3p1h.RoundToPrecision(PRE);
    tmp := s3kp1 * sxh3 / k3p1h;        // 1.4.7.(3k + 1) * x^(3k) / (3*(k+1))!
    s0 := s0 + tmp;                     // 
    s0 := s0.RoundToPrecision(PRE);
    if s0 = sb then break;
    sb := s0;
  end;
  s0 := s0 + 1;                         // 1 + 

  s1 := 0;                              // l 0
  sb := 0;                              // x^3k
  sxh3 := '1';                          // x^(3k)
  s3kp2 := '1';                         // 1   *(3k+2)
  k3p11h := '1';                        // 1   (3*(k+1)+1)!
  for k := 0 to KMmax do begin
    sxh3 := sxh3 * xh3;                 // x^(3k)
    sxh3 := sxh3.RoundToPrecision(PRE);
    k3P2 := 3 * k + 2;                  // 3k+2
    s3kp2 := s3kp2 * k3P2;              // 2.5.8.(3k+2)
    s3kp2 := s3kp2.RoundToPrecision(PRE);
    k3p11 := 3 * (k + 1) + 1;           // 3*(k+1)+1
    k3p11h := k3p11h * (k3p11 - 2) * (k3p11 - 1) * (k3p11); // (3*(k+1)+1)!
    k3p11h := k3p11h.RoundToPrecision(PRE);
    tmp := s3kp2 * sxh3 / k3p11h;       // 2.5.8.(3k+2) * x^(3k) / ((3*(k+1)+1)!)
    s1 := s1 + tmp;                     // 
    s1 := s1.RoundToPrecision(PRE);
    if s1 = sb then break;
    sb := s1;
  end;
  s1 := s1 * x + x;                     // x + x

  ai0 := Ai0S;
  aid := AidS;
  bi0 := Bi0S;
  bid := BidS;

  Ai := s0 * ai0;
  Ai := Ai + s1 * aid;
  Bi := s0 * bi0;
  Bi := Bi + s1 * bid;
end;
//------------------------------------------------------------------------------


const
  XinMIN = -75;
  XinMAX = 25;

// vZ
// x̒l傫Ȃƌ덷傫Ȃ܂B
// ta[]OtpvZ_
procedure TForm1.Button1Click(Sender: TObject);
label
  EXT;
const
  N = 200;
  XLIM = -2;
  CHA = -3;
var
  ch, i : integer;
  xin : double;
  xmin, xmax, dx, xg : double;
  Aid, Bid : double;
  xb, Ai, Bi, Air, Bir : bigdecimal;
  xm, Aim, Bim : mp_float;
begin
  memo1.Clear;
  memo1.Font.Size := 11;
  val(labelededit2.Text, xin, ch);
  if ch <> 0 then begin
    application.MessageBox('x̒lɊԈႢ܂B','', 0);
    exit;
  end;

  if xin < XinMIN then begin
    application.MessageBox(pwidechar('x̐Βl' + intTostr(XinMIN) + '傫ĉB'),'', 0);
    exit;
  end;
  if xin > XinMAX then begin
    application.MessageBox(pwidechar('x̐Βl' + intTostr(XinMax) + '菬ĉB'),'', 0);
    exit;
  end;

  mpf_init3(xm, Aim, Bim);

  series1.Clear;
  series2.Clear;
  series3.Clear;
  series4.Clear;

  application.ProcessMessages;

  memo1.Lines.Append('GA[֐ }N[WJ');

  if (xin <= 3) and (xin >= -8) then begin
    memo1.Lines.Append(' double Z');
    Airy_double(xin, Aid, Bid);
    memo1.Lines.Append('Z 1    Ai(x) = ' + floattostr(Aid));
    memo1.Lines.Append('@@@      Bi(x) = ' + floattostr(Bid));
    AiryA_double(xin, Aid, Bid);
    memo1.Lines.Append('Z 2    Ai(x) = ' + floattostr(Aid));
    memo1.Lines.Append('            Bi(x) = ' + floattostr(Bid));
  end;

  xb := labelededit2.Text;

  Airy_functions(xb, Ai, Bi);

  air := Ai.RoundToPrecision(50);                  // 50Ɋۂ
  bir := Bi.RoundToPrecision(50);


  memo1.Lines.Append('Ai(x) = ' + air.ToString);
  memo1.Lines.Append('Bi(x) = ' + bir.ToString);

  if checkbox1.Checked = false then begin          // OtI
      Chart1.Canvas.Font.Style := [fsBold];
      Chart1.Canvas.Font.size := 8;
      Chart1.Canvas.TextOut(170, 115,'Ot');
    goto EXT;
  end;

// Ot\
  Aid := Ai.AsDouble;
  Bid := Bi.AsDouble;
  series3.AddXY(xin, Aid);
  series4.AddXY(xin, Bid);
  xmin := round(xin) - 8;
  if xmin < XinMIN then xmin := XinMIN;
  xmax := xmin + 13;
  if xmax > XinMAX then begin
    xmax := XinMAX;
    xmin := XinMAX - 13;
  end;
  dx := (xmax - xmin) / N;
  for i := 0 to N do begin
    xg := dx * i + xmin;
    xb := floatTostr(xg);
    mpf_set_dbl(xm, xg);
    if xg > abs(CHA) then begin
      AiryL_functions(xm, Aim, Bim);
      series1.AddXY(xg, mpf_todouble(Aim));
      series2.AddXY(xg, mpf_todouble(BiM));
    end
    else
      if xg < CHA then begin
        AiryS_functions(xm, Aim, Bim);
        series1.AddXY(xg, mpf_todouble(Aim));
        series2.AddXY(xg, mpf_todouble(BiM));
      end
      else begin
        Airy_functions(xb, Ai, Bi);
        series1.AddXY(xg, Ai.AsDouble);
        series2.AddXY(xg, Bi.AsDouble);
      end;
  end;

  application.ProcessMessages;
EXT:
  mpf_clear3(xm, Aim, Bim);
end;

// ݒ
procedure TForm1.FormCreate(Sender: TObject);
begin
  BigDecimal.DefaultPrecision := PRE;    // Precision = 250  x = -75`25 50̐xɕKv
  BigDecimal.DefaultRoundingMode := rmNearestUp;
  Labelededit2.EditLabel.Caption := 'x (' + floattostr(XinMIN) + '<=x<=' + floattostr(XinMAX) + ')';

  mpf_init4(zero, one, two, four);
  mpf_init2(three, pai);

  mpf_set0(zero);
  mpf_set1(one);
  mpf_set_int(two, 2);
  mpf_set_int(three, 3);
  mpf_set_int(four, 4);
  mpf_set_pi(pai);
end;

// I
procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  mpf_clear4(zero, one, two, four);
  mpf_clear2(three, pai);
end;

end.
